#include <stdint.h>
#include <avr/io.h>
#include <avr/interrupt.h>

uint8_t counter = 1;
uint8_t leds = 0;

ISR (TIMER0_COMP_vect)
{
  if (counter == 0)
    {
      leds = (leds + 1) % 8;
      PORTC = leds << 4;
    }
  counter++;
}

void init (void)
{
  cli ();
  TCCR0 = (1 << CS01) | (1 << CS00);
  TIMSK = 1 << OCIE0;
  sei ();
  DDRC = 0x70;
}

int main (void)
{
  init ();
  while (1)
    ; /* do nothing */
  return 0;
}
