#include <stdio.h>
#include <string.h>
#include <unistd.h>

int comparisons = 0;

void display (char **name, int left, int right)
{
  printf ("\e[H\e[J");
  for (int i = 0; name[i]; i++)
    {
      printf ("%s", name[i]);
      if (i == left || i == right)
        printf (" <--");
      printf ("\n");
    }
  printf ("%d\n", comparisons);
}

int compare (char **name, int left, int right)
{
  int result = strcmp (name[left], name[right]);
  comparisons++;
  display (name, left, right);
  usleep (200000);
  return result;
}

void sort (char **name)
{
  int sorted = 0;
  while (name[sorted])
    sorted++;
  while (sorted > 0)
    {
      int new_sorted = 0;
      for (int i = 1; i < sorted; i++)
        if (compare (name, i - 1, i) > 0)
          {
            new_sorted = i;
            char *temp = name[i - 1];
            name[i - 1] = name[i];
            name[i] = temp;
          }
      sorted = new_sorted;
    }
}

int main (void)
{
  char *name[] = { "Anna", "Berta", "Box", "Dieter", "Fritz", "Hans", "Heinrich",
                   "Hugo", "Lisa", "Maria", "Otto", "Peter", "Siegfried", "Thomas",
                   "Ulrich", "Zacharias", NULL };
  sort (name);
  display (name, -1, -1);
  return 0;
}
