#include <stdio.h>

#define POINT  0
#define CIRCLE 1
#define TEXT   2

typedef union
{
  int radius;
  char *text;
} extra_data;

typedef struct graphics_object
{
  int type;
  void (*draw) (struct graphics_object *this);
  int x, y;
  extra_data data;
} graphics_object;

void draw_point (struct graphics_object *this)
{
  printf ("point at (%d,%d)\n", this->x, this->y);
}

void draw_circle (struct graphics_object *this)
{
  printf ("circle at (%d,%d) with radius %d\n",
          this->x, this->y, this->data.radius);
}

void draw_text (struct graphics_object *this)
{
  printf ("text at (%d,%d): \"%s\"\n",
          this->x, this->y, this->data.text);
}

int main (void)
{
  graphics_object a_point = { POINT, draw_point, 35, 17 };
  graphics_object a_circle = { CIRCLE, draw_circle, 20, 30 };
  a_circle.data.radius = 12;
  graphics_object some_text = { TEXT, draw_text, 42, 23 };
  some_text.data.text = "Hello, world!";
  graphics_object *g[3] = { &a_point, &a_circle, &some_text };
  for (int i = 0; i < 3; i++)
    g[i]->draw (g[i]);
  return 0;
}
