#include <stdio.h>
#include <stdlib.h>

#define T_BASE    0
#define T_INTEGER 1
#define T_STRING  2

typedef struct
{
  int type;
} t_base;

typedef struct
{
  int type;
  int content;
} t_integer;

typedef struct
{
  int type;
  char *content;
} t_string;

typedef union
{
  t_base base;
  t_integer integer;
  t_string string;
} t_object;

void print_object (t_object *this)
{
  if (this->base.type == T_INTEGER)
    printf ("Integer: %d\n", this->integer.content);
  else if (this->base.type == T_STRING)
    printf ("String: \"%s\"\n", this->string.content);
}

t_object *new_integer (int i)
{
  t_object *p = malloc (sizeof (t_integer));
  p->integer.type = T_INTEGER;
  p->integer.content = i;
  return p;
}

t_object *new_string (char *s)
{
  t_object *p = malloc (sizeof (t_string));
  p->string.type = T_STRING;
  p->string.content = s;
  return p;
}

int main (void)
{
  t_object *object[] = { new_integer (42),
                         new_string ("Hello, world!"),
                         NULL };

  for (int i = 0; object[i]; i++)
    print_object (object[i]);

  return 0;
}
