#include <stdio.h>

#define STACK_SIZE 10

int stack[STACK_SIZE];
int stack_pointer = 0;

void push (int x)
{
  stack[stack_pointer++] = x;
}

void push_at (int x, int pos)
{
  for (int i = stack_pointer - 1; i >= pos; i--)
    stack[i + 1] = stack[i];
  stack[pos] = x;
  stack_pointer++;
}

void push_sorted (int x)
{
  int left = 0;
  int right = stack_pointer;
  while (left < right - 1)
    {
      int i = (left + right) / 2;
      if (x < stack[i])
        right = i;
      else
        left = i;
    }
  push_at (x, left);
}

int pop (void)
{
  return stack[--stack_pointer];
}

void show (void)
{
  printf ("stack:");
  for (int i = 0; i < stack_pointer; i++)
    printf (" %d", stack[i]);
  printf ("\n");
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  show ();
  push_sorted (5);
  show ();
  push_sorted (256);
  show ();
  return 0;
}
